/*!
 * Select Image (jQuery Plugin) v0.9
 *
 * Copyright(c) Hideki Terada
 * https://cube-group.jp/
 *
 * Released under the MIT license
 *
 * Date: 2020-03-15
 */

(function($){
	//jQuery Plugin seelctタグを画像選択できる様にする
	$.fn.selectimage=function(options){
		var opts = $.extend({}, $.fn.selectimage.defaults, options);
    var icon, disp, val, cntopt, offsetY, offsetXL, offsetXR, pos;
		var uniqueId = function(digits) {
		  var strong = typeof digits !== 'undefined' ? digits : 1000;
		  return Date.now().toString(16) + Math.floor(strong * Math.random()).toString(16);
		};
		var changeSelect = function(selectImageID, value) {
      $('select[select-image-id="' + selectImageID + '"]').val( value );
      $('img[select-image-id="' + selectImageID + '"]').attr( 'src', value );
		};
		icon = opts.selecticon;
		if( document.getElementById("selectimage_overlay") == null ){
			$('body').prepend('<div id="selectimage_overlay" style="width:100vw;height:100vh;position:fixed;display:none;" />');
			$('#selectimage_overlay').on('click', function(){
				$('#selectimage_overlay').fadeOut(200);
				$('div#selectimage_container div[select-image-id]').fadeOut(200);
			});
		}
		if( this.length > 0 && document.getElementById("selectimage_container") == null ) $('body').prepend('<div id="selectimage_container" />');
		return this.each(function(){
			if( typeof $(this).attr('select-image-id') != 'undefined' ) return;
      let uniqID = uniqueId();
      val = $(this).attr('select-image-id', uniqID ).find('option:selected').text();
      cntopt = $(this).css('display', 'none').children('option').length;
      disp = $('<div class="selectimage_selected" style="width:' + opts.width +';height:' + opts.height + ';position:relative;" />').insertAfter(this);
      disp.prepend('<img src="' + val + '" alt="" select-image-id="' + uniqID + '" )>');
			$(icon).appendTo(disp).attr('select-image-tid', uniqID).on('click', function(){
				let target = $(this).attr('select-image-tid');
				let zIndex = $('#selectimage_overlay').fadeIn(200).css('z-index');
				offsetY  = $('select[select-image-id="' + target + '"]').css('display', 'block').offset()['top'] + $('img[select-image-id="' + target + '"]').outerHeight();
				$('select[select-image-id="' + target + '"]').css('display', 'none');
				$('div[select-image-id="' + target + '"]').css('top', offsetY + 'px').css('z-index', zIndex + 1).fadeIn(300);
			});
			offsetXL = disp.offset()['left'];
			offsetXR = $('html').width() - (disp.offset()['left'] + disp.outerWidth());
      var imgparline, numoflines;
      if( opts.multiplelines ){
        let maximgparline = Math.floor( $('#selectimage_container').width() / disp.width() );
        numoflines = Math.ceil( cntopt / maximgparline );
        imgparline = Math.ceil( cntopt / numoflines );
      } else {
        imgparline = cntopt;
        numoflines = 1;
      }
			switch( true ){
				case offsetXL + imgparline * disp.width() <= $('#selectimage_container').width():
					pos = 'left:' + offsetXL + 'px;';
					break;
				case offsetXR + imgparline * disp.width() <= $('#selectimage_container').width():
					pos = 'right:' + offsetXR + 'px;';
					break;
				default:
					pos = ''
					break;
			}
			let addElem = $('<div style="display:table;border-collapse:collapse;width:' + disp.width() * imgparline + 'px;" />'), rowImages = '', i = 0;
      $(this).children('option').each(function(){
        i++;
        rowImages += '<div class="selectimage_container_box" style="display:table-cell;position:relative;box-sizing:border-box;width:' + disp.width() + 'px;height:' + disp.height() + 'px;cursor:pointer;"><img src="' + $(this).text() + '" alt="" select-image-tid="' + uniqID + '" value="' + $(this).val() + '"></div>';
        if( i == imgparline ){
          let rowElem = $('<div style="display:table-row;" />');
          rowElem.append(rowImages);
          addElem.append(rowElem);
          rowImages = '';
          i = 0;
        }
      });
      if( i != 0 ){
        let rowElem = $('<div style="display:table-row;" />');
        rowElem.append(rowImages);
        addElem.append(rowElem);
      }
      let wrapElem = $('<div style="width:100%;overflow-x:auto;position:absolute;display:none;' + pos + '" />');
      wrapElem.append(addElem).attr('select-image-id', uniqID);
      $('#selectimage_container').append(wrapElem);
			$('img[select-image-tid="' + uniqID + '"]').on('click', function(){
				let target = $(this).attr('select-image-tid');
				let src = $(this).attr('src');
				let val = $(this).attr('value');
				$('select[select-image-id="' + target + '"]').val( val );
				$('.selectimage_selected').children('img[select-image-id="' + target + '"]').attr('src', src);
				$('#selectimage_overlay').fadeOut(300);
				$('div#selectimage_container div[select-image-id]').fadeOut(200);
			});
		});
	};
	$.fn.selectimage.defaults = {
		width: '200px',
		height: '200px',
    multiplelines: true,
    selecticon: '<i class="fas fa-sort-down"></i>',
	};
})(jQuery);
